; *****************************************************************
; *			    Vianocny had.ASM			  *
; *****************************************************************
; *								  *
; * Autor:	MartiN Valasek					  *
; * Program:	Vianocny had				          *
; * Procesor:	16F84A					  	  *
; * Popis:	Vianocny had blika v roznych efektoch             *
; *							          *
; *************************   AUGUST 2009   *********************
;******************************************************************
;****************************   konstanty   ******************
SMER	equ	0CH
CAKAJ3	equ	0DH
CAKAJ2	equ	0EH
CAKAJ1	equ	0FH
JASOV	equ	10H
JASOV0	equ	11H
JASOV1	equ	12H
JASOVL	equ	13H
JASOVH	equ	14H
CAKAJ6	equ	15H
CAKAJ5	equ	16H
CAKAJ4	equ	17H
LED	equ	18H
PIPLH	equ	1AH
PIP	equ	1BH
RYCH	equ	1CH
RYCH2	equ	1DH
RYCH3	equ	1EH
PROG	equ	1FH
CISLO	equ	20H

STATUS	equ	03H
PORTA	equ	05H
PORTB	equ	06H
;*************************************************************
_CP_ON		EQU     H'000F'
_CP_OFF         EQU     H'3FFF'
_PWRT_ON        EQU     H'3FF7'
_PWRT_OFF       EQU     H'3FFF'
_WDT_ON         EQU     H'3FFF'
_WDT_OFF        EQU     H'3FFB'
_RC_OSC	        EQU     H'3FFF'
;*************************************************************
	list p=16f84		; typ PIC 
;*************************************************************
;*************  zap./vyp. - WDT,PWRT,CP ;  typ oscilatora  *** 

	__CONFIG _CP_OFF & _PWRT_OFF & _WDT_OFF & _RC_OSC  
;****************************
	org	000
;*************************************************************
;*************************************************************
	MOVLW	B'00000011'	; nastav I/O na RA
	TRIS	PORTA
	MOVLW	B'00000000'	; nastav I/O na RB
	TRIS	PORTB	
	MOVLW	B'00001000'	; nastav H/L na RA
	MOVWF	PORTA
	MOVLW	B'00000000'	; nastav L na RB
	MOVWF	PORTB
		
	MOVLW	D'3'		; nastav reg RYCH do 1 
	MOVWF	RYCH
	
		; po spusteny otestuje displej a piezo reproduktor 		
	BCF	PORTA,3		; zapni bodku na displeji
	MOVLW	D'8'		; nastavenie cisla efektu na displeji
	MOVWF	CISLO
	CALL	DISP

	CALL	PIPNI		; dlhe pipnutie 
	CALL	PIPNI
	CALL	PIPNI
	CALL	PIPNI		 	
;*************************************************************
;******************************	  svetelne efekty   **********
;****************   EFEKT 1   ****************	
;********  pravy smer   *******
EFEKT1	BSF	PORTA,3		; vypni bodku na displeji
	MOVLW	D'1'		; nastavenie cisla efektu na displeji
	MOVWF	CISLO
	CALL	DISP

	MOVLW	D'10'		; nastavenie rychlosti efektu
	MOVWF	RYCH2
	MOVLW	D'1'		; nastavenie rychlosti stmiev./roztmiev.
	MOVWF	RYCH3

P	MOVLW	D'30'		; po 30x sa zmen smer dolava 
	MOVWF	SMER

HADP
;******  1 LED ******
	MOVLW	B'00000001'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE

;******  2 LED ******
	MOVLW	B'00000010'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE	; preskoc na stmievanie

;******  3 LED ******
	MOVLW	B'00000100'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE	; preskoc na stmievanie	

	CALL	TL1		; kontrola tlacidla efektu
	GOTO	SMERP		;ak sa 30x zopakoval efekt prehod smer 	   	
;*****************************
;********  lavy smer   *******
L	MOVLW	D'30'		;po 30x sa zmen smer doprava 
	MOVWF	SMER

HADL
;******  3 LED ******
	MOVLW	B'00000100'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE

;******  2 LED ******
	MOVLW	B'00000010'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE

;******  1 LED ******
	MOVLW	B'00000001'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE

	CALL	TL1		; kontrola tlacidla efektu
	GOTO	SMERL		;ak sa 30x zopakoval efekt prehod smer 
;*****************************   zmena smeru   ***************      
SMERP	DECFSZ	SMER,1
	GOTO	HADP
	GOTO 	L
;*****************************
SMERL	DECFSZ	SMER,1
	GOTO	HADL
	GOTO 	P
;******  tlacidlo  *********************
TL1	BTFSS	PORTA,0		; kontrola stlacenia tlacidla - efektu
	GOTO	$+4		; ak tlacidlo nieje stlacene pokracuj v efekte
	CALL	ONESTL		; pre oneskorenie preskoc na ONESTL
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla po oneskoreni
	GOTO	EFEKT2	 	; ak tlacidlo je stlacene skoc na dalsi efekt
	RETURN
;*************************************************************
;****************   EFEKT 2   ****************
EFEKT2	MOVLW	D'2'		; nastavenie cisla efektu na displeji
	MOVWF	CISLO
	CALL	DISP
	
	MOVLW	D'10'		; nastavenie rychlosti efektu
	MOVWF	RYCH2
	MOVLW	D'1'		; nastavenie rychlosti stmiev./roztmiev.
	MOVWF	RYCH3
	
;******  1 LED ******
	MOVLW	B'00000001'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE

;******  2 LED ******
	MOVLW	B'00000010'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE	; preskoc na stmievanie

;******  3 LED ******
	MOVLW	B'00000100'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE	; preskoc na stmievanie

;******  tlacidlo  *********************
TL2	BTFSS	PORTA,0		; kontrola stlacenia tlacidla - efektu
	GOTO	$+4		; ak tlacidlo nieje stlacene pokracuj v efekte
	CALL	ONESTL		; pre oneskorenie preskoc na ONESTL
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla po oneskoreni		
	GOTO	EFEKT3	 	; ak tlacidlo je stlacene skoc na dalsi efekt
	
	GOTO	EFEKT2		; po dokonceni cyklu vrat sa na zaciatok
;*************************************************************
;****************   EFEKT 3   ****************
EFEKT3	MOVLW	D'3'		; nastavenie cisla efektu na displeji
	MOVWF	CISLO
	CALL	DISP

	MOVLW	D'10'		; nastavenie rychlosti efektu
	MOVWF	RYCH2
	MOVLW	D'2'		; nastavenie rychlosti stmiev./roztmiev.
	MOVWF	RYCH3

;******  1 LED ******
	MOVLW	B'00000001'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE

;******  2 LED ******
	MOVLW	B'00000010'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE	; preskoc na stmievanie

;******  3 LED ******
	MOVLW	B'00000100'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE	; preskoc na stmievanie

;******  2 LED ******
	MOVLW	B'00000010'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE	; preskoc na stmievanie

;******  tlacidlo  **********************
TL3	BTFSS	PORTA,0		; kontrola stlacenia tlacidla - efektu
	GOTO	$+4		; ak tlacidlo nieje stlacene pokracuj v efekte
	CALL	ONESTL		; pre oneskorenie preskoc na ONESTL
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla po oneskoreni	
	GOTO	EFEKT4	 	; ak tlacidlo je stlacene skoc na dalsi efekt
	
	GOTO	EFEKT3		; po dokonceni cyklu vrat sa na zaciatok
;*************************************************************
;****************   EFEKT 4   ****************
EFEKT4	MOVLW	D'4'		; nastavenie cisla efektu na displeji
	MOVWF	CISLO
	CALL	DISP

	MOVLW	D'30'		; nastavenie rychlosti efektu
	MOVWF	RYCH2
	MOVLW	D'22'		; nastavenie rychlosti stmiev./roztmiev.
	MOVWF	RYCH3
	
;******  LED ******
	MOVLW	B'00000001'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie
	MOVLW	B'00000100'	; poradie LED
	MOVWF	LED
	CALL	STMIE		; preskoc na STMIEVANIE 
	CALL	CAKAJ		; preskoc na CAKANIE

	MOVLW	B'00000010'	; poradie LED
	MOVWF	LED
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie
	MOVLW	B'00000001'
	MOVWF	LED
	CALL	STMIE		; preskoc na STMIEVANIE
	CALL	CAKAJ		; preskoc na CAKANIE

	MOVLW	B'00000100'	; poradie LED
	MOVWF	LED
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie
	MOVLW	B'00000010'
	MOVWF	LED
	CALL	STMIE		; preskoc na STMIEVANIE
	CALL	CAKAJ		; preskoc na CAKANIE

;******  tlacidlo  *********************
TL4	BTFSS	PORTA,0		; kontrola stlacenia tlacidla - efektu
	GOTO	$+4		; ak tlacidlo nieje stlacene pokracuj v efekte
	CALL	ONESTL		; pre oneskorenie preskoc na ONESTL
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla po oneskoreni
	GOTO	EFEKT5	 	; ak tlacidlo je stlacene skoc na dalsi efekt
	
	GOTO	EFEKT4		; po dokonceni cyklu vrat sa na zaciatok	
;*************************************************************
;****************   EFEKT 5   ****************
EFEKT5	MOVLW	D'5'		; nastavenie cisla efektu na displeji
	MOVWF	CISLO
	CALL	DISP
	
	MOVLW	D'35'		; nastavenie rychlosti efektu
	MOVWF	RYCH2
	MOVLW	D'10'		; nastavenie rychlosti stmiev./roztmiev.
	MOVWF	RYCH3
	
;******  LED 1 ******
	MOVLW	B'00000001'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie
	CALL	CAKAJ		; preskoc na CAKANIE

;******  LED 2 ******
	MOVLW	B'00000010'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	MOVLW	B'00000011'	; poradie LED
	MOVWF	LED
	CALL	SVIET		; preskoc na trvale SVIETenie
	CALL	CAKAJ		; preskoc na CAKANIE

;******  LED 3 ******
	MOVLW	B'00000100'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	MOVLW	B'00000111'	; poradie LED
	MOVWF	LED
	CALL	SVIET		; preskoc na trvale SVIETenie
	CALL	CAKAJ		; preskoc na CAKANIE

;****  prestavka  ***	
	CALL	CAKAJ		; 2x preskoc na CAKANIE
	CALL	CAKAJ		
	MOVLW	B'00000000'	; poradie LED
	MOVWF	LED
	CALL	SVIET		; preskoc na trvale SVIETenie (zhasnutie)
	CALL	CAKAJ		; 4x preskoc na CAKANIE, kvoli dlzke prestavky 
	CALL	CAKAJ		 
	CALL	CAKAJ		 
	CALL	CAKAJ		
	
;******  tlacidlo  *********************
TL5	BTFSS	PORTA,0		; kontrola stlacenia tlacidla - efektu
	GOTO	$+4		; ak tlacidlo nieje stlacene pokracuj v efekte
	CALL	ONESTL		; pre oneskorenie preskoc na ONESTL
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla po oneskoreni
	GOTO	EFEKT6	 	; ak tlacidlo je stlacene skoc na dalsi efekt
	
	GOTO	EFEKT5		; po dokonceni cyklu vrat sa na zaciatok	
;*************************************************************
;****************   EFEKT 6  ****************	
;********  pravy smer   *******
EFEKT6	MOVLW	D'6'		; nastavenie cisla efektu na displeji
	MOVWF	CISLO
	CALL	DISP

	MOVLW	D'70'		; nastavenie rychlosti efektu
	MOVWF	RYCH2
	MOVLW	D'15'		; nastavenie rychlosti stmiev./roztmiev.
	MOVWF	RYCH3

P2	MOVLW	D'20'		; po 20x sa zmen smer dolava 
	MOVWF	SMER

HADP2
;******  1 LED ******
	MOVLW	B'00000001'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE

;******  2 LED ******
	MOVLW	B'00000010'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE	; preskoc na stmievanie

;******  3 LED ******
	MOVLW	B'00000100'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE	; preskoc na stmievanie	

	CALL	TL6		; kontrola tlacidla efektu
	GOTO	SMERP2		;ak sa 20x zopakoval efekt prehod smer 	   	
;*****************************
;********  lavy smer   *******
L2	MOVLW	D'20'		;po 20x sa zmen smer doprava 
	MOVWF	SMER

HADL2
;******  3 LED ******
	MOVLW	B'00000100'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE

;******  2 LED ******
	MOVLW	B'00000010'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE

;******  1 LED ******
	MOVLW	B'00000001'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE

	CALL	TL6		; kontrola tlacidla efektu
	GOTO	SMERL2		;ak sa 20x zopakoval efekt prehod smer 
;*****************************   zmena smeru   ***************      
SMERP2	DECFSZ	SMER,1
	GOTO	HADP2
	GOTO 	L2
;*****************************
SMERL2	DECFSZ	SMER,1
	GOTO	HADL2
	GOTO 	P2
;******  tlacidlo  *********************
TL6	BTFSS	PORTA,0		; kontrola stlacenia tlacidla - efektu
	GOTO	$+4		; ak tlacidlo nieje stlacene pokracuj v efekte
	CALL	ONESTL		; pre oneskorenie preskoc na ONESTL
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla po oneskoreni	
	GOTO	EFEKT7	 	; ak tlacidlo je stlacene skoc na dalsi efekt
	RETURN
;*************************************************************
;****************   EFEKT 7   ****************
EFEKT7	MOVLW	D'7'		; nastavenie cisla efektu na displeji
	MOVWF	CISLO
	CALL	DISP

	MOVLW	D'250'		; nastavenie rychlosti efektu
	MOVWF	RYCH2
	MOVLW	D'25'		; nastavenie rychlosti stmiev./roztmiev.
	MOVWF	RYCH3

;******  1,2,3 LED ******
	MOVLW	B'00000111'	; poradie LED
	MOVWF	LED		
	CALL	ROZTMIE		; preskoc na ROZTMIEVANIE
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	CALL	STMIE		; preskoc na STMIEVANIE
	CALL	CAKAJ		; preskoc na CAKANIE


;******  tlacidlo  *********************
TL7	BTFSS	PORTA,0		; kontrola stlacenia tlacidla - efektu
	GOTO	$+4		; ak tlacidlo nieje stlacene pokracuj v efekte
	CALL	ONESTL		; pre oneskorenie preskoc na ONESTL
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla po oneskoreni		
	GOTO	EFEKT8	 	; ak tlacidlo je stlacene skoc na dalsi efekt
	
	GOTO	EFEKT7		; po dokonceni cyklu vrat sa na zaciatok
;*************************************************************
;****************   EFEKT 8 - trvale svietenie  ***********
EFEKT8	MOVLW	D'8'		; nastavenie cisla efektu na displeji
	MOVWF	CISLO
	CALL	DISP

	MOVLW	D'2'		; nastavenie (rychlosti efektu)
	MOVWF	RYCH2

;******  1,2,3 LED ******
	MOVLW	B'00000111'	; poradie LED
	MOVWF	LED		
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE

;******  tlacidlo  *********************
TL8	BTFSS	PORTA,0		; kontrola stlacenia tlacidla - efektu
	GOTO	$+4		; ak tlacidlo nieje stlacene pokracuj v efekte
	CALL	ONESTL		; pre oneskorenie preskoc na ONESTL
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla po oneskoreni		
	GOTO	EFEKT0	 	; ak tlacidlo je stlacene skoc na dalsi efekt
	
	GOTO	EFEKT8		; po dokonceni cyklu vrat sa na zaciatok
;*************************************************************
;****************   EFEKT 0 - nic nesvieti  ***************
EFEKT0	BCF	PORTA,3		; zapni bodku na displeji
	MOVLW	D'15'		; nastavenie cisla efektu na displeji
	MOVWF	CISLO
	CALL	DISP
	CALL	CAKAJ		; predlzenie doby, pre blikanie bodky

	MOVLW	D'35'		; nastavenie (rychlosti blikania bodky)
	MOVWF	RYCH2
	
	BSF	PORTA,3		; vypni bodku na displeji
	CALL	CAKAJ		; 3x predlzenie doby, pre blikanie bodky	
	CALL	CAKAJ		
	CALL	CAKAJ		 	

;******  1,2,3 LED ******
	MOVLW	B'00000000'	; poradie LED
	MOVWF	LED		
	CALL	SVIET		; preskoc na trvale SVIETenie 
	CALL	CAKAJ		; preskoc na CAKANIE
	
;******  tlacidlo  *********************
TL0	BTFSS	PORTA,0		; kontrola stlacenia tlacidla - efektu
	GOTO	$+4		; ak tlacidlo nieje stlacene pokracuj v efekte
	CALL	ONESTL		; pre oneskorenie preskoc na ONESTL
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla po oneskoreni		
	GOTO	EFEKT1	 	; ak tlacidlo je stlacene skoc na dalsi efekt
	
	GOTO	EFEKT0		; po dokonceni cyklu vrat sa na zaciatok
;*************************************************************	
;*****************************   oneskorenie   ***************
CAKAJ	MOVF	RYCH,0		; casova slucka 3 
	ADDWF	RYCH,0		; hodnotu vynasobi x 2 
	MOVWF	CAKAJ3

NASTAV1	MOVF	RYCH2,0		; casova slucka 2
	MOVWF	CAKAJ2

NASTAV2	MOVLW	D'60'		; casova slucka 1
	MOVWF	CAKAJ1
	CLRWDT

NASTAV3	CALL	RYCHLO		; kontrola stlacenia tlacidla - rychlosti
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla - efektu
	RETURN			; ak je stlacene, navrat do programu 

	DECFSZ	CAKAJ1,1	; cyklus 1
	GOTO	NASTAV3
	DECFSZ	CAKAJ2,1	; cyklus 2
	GOTO	NASTAV2
	DECFSZ	CAKAJ3,1	; cyklus 3
	GOTO	NASTAV1
    	RETURN			; navrat	
;*************************************************************
;*****************************  impulzna regulacia jasu  *****
;*****************************  roztmievanie  ****************
ROZTMIE	MOVLW	D'20'		; 20 krokov na zmenu JASu
	MOVWF	JASOVL
	MOVWF	JASOV0

NASTAV6	MOVF	JASOVL,0
	MOVWF	JASOV0
	SUBLW	D'20'
	MOVWF	JASOVH
	MOVWF	JASOV1	

	MOVF	RYCH,0		; casova slucka 2 	
	ADDWF	RYCH3,0
	MOVWF	CAKAJ5

NASTAV4	MOVF	RYCH3,0		; casova slucka 1
	MOVWF	CAKAJ4
	CLRWDT	
	
JAS1	MOVF	JASOV1,0	; ak sa JASOV0 = 0, tak preskoc nastavenie H 
	BTFSC	STATUS,2
	GOTO	JAS0	
	CALL	PORADH		; zisti poradie LED, nastavie PORTB
	DECFSZ	JASOV1,1
	GOTO	JAS1
		
	
JAS0	MOVF	JASOV0,0	; ak sa JASOV1 = 0, tak preskoc nastavenie L 
	BTFSC	STATUS,2
	GOTO	NASTAV5
	CALL	PORADL		; zisti poradie LED, nastavie PORTB
	DECFSZ	JASOV0,1
	GOTO	JAS0
	
NASTAV5	CALL	RYCHLO		; kontrola stlacenia tlacidla - rychlosti
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla - efektu
	RETURN			; ak je stlacene, navrat do programu 
	
	MOVF	JASOVL,0
	MOVWF	JASOV0
	MOVF	JASOVH,0
	MOVWF	JASOV1

	DECFSZ	CAKAJ4,1	; cyklus 1
	GOTO	JAS1
	DECFSZ	CAKAJ5,1	; cyklus 2
	GOTO	NASTAV4
	
	MOVF	JASOVL,0	; ak sa JASOVL = 0 
	BTFSC	STATUS,2
	RETURN			; navrat do programu
	DECF	JASOVL,1
	GOTO	NASTAV6
;*********************************  stmievanie  ********
STMIE	MOVLW	D'20'		; 20 krokov na zmenu JASu
	MOVWF	JASOVH
	MOVWF	JASOV1

NASTAV9	MOVF	JASOVH,0
	MOVWF	JASOV1
	SUBLW	D'20'
	MOVWF	JASOVL
	MOVWF	JASOV0	

	MOVF	RYCH,0		; casova slucka 2 	
	ADDWF	RYCH3,0
	MOVWF	CAKAJ5

NASTAV7	MOVF	RYCH3,0		; casova slucka 1
	MOVWF	CAKAJ4
	CLRWDT	
	
JAS1S	MOVF	JASOV1,0	; ak sa JASOV0 = 0, tak preskoc nastavenie H 
	BTFSC	STATUS,2
	GOTO	JAS0S	
	CALL	PORADH		; zisti poradie LED, nastavie PORTB
	DECFSZ	JASOV1,1
	GOTO	JAS1S
		
	
JAS0S	MOVF	JASOV0,0	; ak sa JASOV1 = 0, tak preskoc nastavenie L 
	BTFSC	STATUS,2
	GOTO	NASTAV8
	CALL	PORADL		; zisti poradie LED, nastavie PORTB
	DECFSZ	JASOV0,1
	GOTO	JAS0S
		
NASTAV8	CALL	RYCHLO		; kontrola stlacenia tlacidla - rychlosti
	BTFSC	PORTA,0		; kontrola stlacenia tlacidla - efektu
	RETURN			; ak je stlacene, navrat do programu 

	MOVF	JASOVL,0
	MOVWF	JASOV0
	MOVF	JASOVH,0
	MOVWF	JASOV1

	DECFSZ	CAKAJ4,1	; cyklus 1
	GOTO	JAS1S
	DECFSZ	CAKAJ5,1	; cyklus 2
	GOTO	NASTAV7
	
	MOVF	JASOVH,0	; ak sa JASOVH = 0 
	BTFSC	STATUS,2
	RETURN			; navrat do programu
	DECF	JASOVH,1
	GOTO	NASTAV9
;**********************************  poradie LED  ************
;**********************************  pre log H (1)  **********
PORADH	BTFSC	LED,0		; test bitu c.: 0
	BSF	PORTB,6	
	BTFSC	LED,1		; test bitu c.: 1	
	BSF	PORTB,5	
	BTFSC	LED,2		; test bitu c.: 2	
	BSF	PORTB,4	
	RETURN			; vrat sa spat do programu
;**********************************  pre log L (0)  **********
PORADL	BTFSC	LED,0		; test bitu c.: 0
	BCF	PORTB,6	
	BTFSC	LED,1		; test bitu c.: 1	
	BCF	PORTB,5	
	BTFSC	LED,2		; test bitu c.: 2	
	BCF	PORTB,4
	RETURN			; vrat sa spat do programu
;*************************************************************
;******************************  trvale svietenie LED  *******
SVIET	BCF	PORTB,6		; LED 1  -  do L
	BTFSC	LED,0		; testuje bit reg LED  
	BSF	PORTB,6		; ak je bit v H nastav LED do H
	BCF	PORTB,5		; LED 2	 -  do L
	BTFSC	LED,1		; testuje bit reg LED		
	BSF	PORTB,5		; ak je bit v H nastav LED do H
	BCF	PORTB,4		; LED 3	 -  do L
	BTFSC	LED,2		; testuje bit reg LED		
	BSF	PORTB,4		; ak je bit v H nastav LED do H
	
	RETURN			; vrat sa spat do programu  
;***********************************  pipnutie pieza  ********	
PIPNI	MOVLW	D'50'
	MOVWF	PIP		; nastav reg PIP - dlzka pipnutia

TON	MOVLW	D'255'
	MOVWF	PIPLH		; nastav reg PIPLH - kmitocet pipnutia
	
	BSF	PORTA,4		; nastav PIN4 na PORTA do H
	DECFSZ	PIPLH,1		; ak PIPLH = 0, skoc na L   
	GOTO	$-2		; ak PIPLH <> 0, opakuj
	
	MOVLW	D'180'
	MOVWF	PIPLH		; nastav reg PIPLH - kmitocet pipnutia		
	
	BCF	PORTA,4		; nastav PIN4 na PORTA do L	
	DECFSZ	PIPLH,1		; ak PIPLH = 0, skoc na (H)
	GOTO	$-2		; ak PIPLH <> 0, opakuj

	DECFSZ	PIP,1		
	GOTO	TON		; ak TON <> 0, opakuj impulz 
	RETURN			; ak TON = 0, navrat do programu
;*********************************************************************
;**********************************   rychlost efektu  ***************
RYCHLO	BTFSS	PORTA,1		; kontrola stlacenia tlacidla - rychlosti
	RETURN			; ak tlacidlo nieje stlacene pokracuj v efekte
	BCF	PORTA,3		; zapni bodku na displeji
	MOVF	CISLO,0
	MOVWF	PROG		; presune cislo efektu z CISLO do PROG

	MOVF	RYCH,0
	MOVWF	CISLO		; presune rychlost efektu z RYCH do CISLO	
	CALL	DISP		; zobraz aktualnu rychlost efektu
	MOVF	PROG,0
	MOVWF	CISLO		; presune cislo efektu naspat z PROG do CISLO
	CALL	ONESTL		; pre oneskorenie preskoc na ONESTL
	
	CALL	DISP		; zobraz cislo efektu
	BSF	PORTA,3		; vypni bodku na displeji

	BTFSS	PORTA,1		; kontrola stlacenia tlacidla po oneskoreni
	RETURN			; ak tlacidlo nieje stlacene pokracuj v efekte
	
	MOVF	RYCH,0		; reg RYCH sa skopiruje do W
	INCF 	RYCH,1		; k registru RYCH +1 
 	MOVF	RYCH,0		; zkopiruj reg RYCH do W
	SUBLW	D'6'		; zisti ci stav reg RYCH je viac ako 5
	BTFSS	STATUS,2	;
	RETURN			; ak je menej ako 5 (>0), vrat sa do programu
	MOVLW	D'1'		; ak je viac ako 5 (=0),
	MOVWF	RYCH		;      	     nastav reg RYCH na 1

 	RETURN			; vrat sa do programu 	 	
;***************************************************************************
;*****************************   oneskorenie pre tlacidlo  ***************
ONESTL	MOVLW	D'255'		; casova slucka 2
	MOVWF	CAKAJ2

NAST10	MOVLW	D'255'		; casova slucka 1
	MOVWF	CAKAJ1
	CLRWDT

NAST11	GOTO	$+1		; predlzenie cakacej doby 
	GOTO	$+1	
	GOTO	$+1
	DECFSZ	CAKAJ1,1	; cyklus 1
	GOTO	NAST11
	GOTO	$+1		; predlzenie cakacej doby 
	GOTO	$+1	
	GOTO	$+1
	DECFSZ	CAKAJ2,1	; cyklus 2
	GOTO	NAST10
	
	BTFSC	PORTA,0		; test tlacidla efektu
	CALL	PIPNI		; ak tlacidlo je stale stlacene, pipni 
	BTFSC	PORTA,1		; test tlacidla rychlosti
	CALL	PIPNI		; ak tlacidlo je stale stlacene, pipni
    	RETURN			; navrat	
;***************************************************************************
;********************************  zobrazenie cislo na displeji  ***********
DISP	BCF	PORTB,0		; nastavenie cis. hodnoti 1
	BTFSC	CISLO,0
	BSF	PORTB,0		
	
	BCF	PORTB,2		; nastavenie cis. hodnoti 2
	BTFSC	CISLO,1
	BSF	PORTB,2
	
	BCF	PORTB,3		; nastavenie cis. hodnoti 4
	BTFSC	CISLO,2
	BSF	PORTB,3
	
	BCF	PORTB,1		; nastavenie cis. hodnoti 8
	BTFSC	CISLO,3
	BSF	PORTB,1
	
	RETURN			; navrat do programu
;**************************************************************************
;**************************************************************************
	END
